<!-- GENERATED BY A EUPHORIA PROGRAM. DO NOT EDIT! -->


<html>
<head><title>The Euphoria Editor</title>
<style type="text/css">
<!--
body        {background-color: "#FFFFFF";}
a           {text-decoration: none;}
a:link      {color: "#0033BB"; text-decoration: underline;}
a:visited   {color: "#006699"; text-decoration: underline;}
a:active    {color: red; text-decoration: underline;}
a:hover     {color: red; text-decoration: underline;}
a.blue    {text-decoration: none;}
a.blue:link      {color: "#5500FF"; text-decoration: underline;}
a.blue:visited   {color: "#5500FF"; text-decoration: underline;}
a.blue:active    {color: red; text-decoration: underline;}
a.blue:hover     {color: red; text-decoration: underline;}
a.brown      {text-decoration: none;}
a.brown:link      {color: "#993333"; text-decoration: underline;}
a.brown:visited   {color: "#993333"; text-decoration: underline;}
a.brown:active    {color: red; text-decoration: underline;}
a.brown:hover     {color: red; text-decoration: underline;}
-->
</style>

</head>
<body bgcolor="#FFFFFF" link="#0033BB" vlink="#006699">
<table width=90% border=0><tr><td>

<center><font face="Arial, Helvetica" color="#FF0099" size=+2>
<br>
 The Euphoria Editor
</font></center>

<p>
<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Introduction
</font>

<p>
The Euphoria download package includes a handy, text-mode editor, ed,
that's written completely in Euphoria. Many people find ed convenient
for editing Euphoria programs and other files,
but there is no requirement that you use it.
<p>
If you don't like <b>ed</b>, you have many alternatives. David Cuny's
<b>EE editor</b> is a DOS-based editor for Euphoria that's also 
written in Euphoria. It has a friendly mouse-based user interface 
with drop down menus etc. It's available from the RDS Web site. 
There are several other Euphoria-oriented editors that run on 
DOS, Windows, Linux and FreeBSD. Check the <b>Editors</b> section of our 
Archive. In fact, <i>any</i> text editor can be used to edit a Euphoria
program, including DOS Edit or Windows NotePad.<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
Summary
</font>

<p>&nbsp;<br>
<b><font face="Arial, Helvetica" color="#003366">
 usage 1: &nbsp; ed filename<br>
 usage 2: &nbsp; ed
</font></b>

<p>
 After any error, just type <font color="#993333"><b>ed</b></font>, and
 you'll be placed in the editor, at the line and column where the error was
 detected. The error message will be at the top of your screen.
<p>
 Euphoria-related files are
 displayed in color. Other text files are in mono. You'll know that you have
 misspelled something when the color does not change as you expect.
 Keywords are blue. Names of routines that are built in to the interpreter
 appear in magenta. Strings are
 green, comments are red, most other text is black. Balanced brackets (on the
 same line) have the same color. <b><font color="#006633">You can change
 these colors as well as several other parameters
 of</font> <font color="#993333">ed</font><font color="#006633">.</font></b>
 See "user-modifiable parameters" near the top of
 <font color="#5500FF"><b>ed.ex</b></font>.
<p>
 The arrow keys move the cursor left, right, up or down. Most other characters
 are immediately inserted into the file.
<p>
 In Windows, you can "associate" various types of files with
 <font color="#5500FF"><b>ed.bat</b></font>. You will then be put into
 <font color="#993333"><b>ed</b></font> when you <b>double-click</b>
 on these types of files - e.g. <b>.e</b>, <b>.pro</b>, <b>.doc</b> etc.
 Main Euphoria files ending in <b>.ex</b> (<b>.exw</b>) might better be
 associated with <font color="#993333"><b>ex.exe</b></font>
 (<font color="#993333"><b>exw.exe</b></font>).
<p>
 <font color="#993333"><b>ed</b></font> is a
 <font color="#CC0099"><b>multi-file/multi-window</b></font> DOS editor.
 <b>Esc c</b> will split your screen so you can view and edit up to 10 files
 simultaneously, with cutting and pasting between them. You can also use
 multiple edit windows to view and edit different parts of a single file. 

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<p>

Special Keys
</font>

<p>Some PC keys do not work in a Linux or FreeBSD text console, or in Telnet, 
and some keys do not work in an xterm under X windows. Alternate keys 
have been provided. In some cases on Linux/FreeBSD you might have to 
edit ed.ex to map the desired key to the desired function.

<p>

<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#006699">Delete</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Delete the current character above the cursor.</td></tr>


<tr><td valign=top><b><font color="#006699">Backspace</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move the cursor to the left and delete a character.</td></tr>


<tr><td valign=top><b><font color="#006699">control-Delete</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Delete the current line. (<b>control-Delete</b> is not
   available on all systems.)</td></tr>


<tr><td valign=top><b><font color="#006699">control-d</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Delete the current line. (same as <b>control-Delete</b>)</td></tr>


<tr><td valign=top><b><font color="#006699">Insert</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Re-insert the preceding series of <b>Deletes</b> or
   <b>control-Deletes</b> before the current character or current line.</td></tr>


<tr><td valign=top><b><font color="#006699">control-arrow-left</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the start of the previous word. On Linux/FreeBSD use
   <b>control-L</b>.</td></tr>


<tr><td valign=top><b><font color="#006699">control-arrow-right</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the start of the next word. On Linux/FreeBSD use 
    <b>control-R</b>.</td></tr>


<tr><td valign=top><b><font color="#006699">Home</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the beginning of the current line.</td></tr>


<tr><td valign=top><b><font color="#006699">End</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the end of the current line.</td></tr>


<tr><td valign=top><b><font color="#006699">control-Home</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the beginning of the file. This works with ex.exe only.
  On Windows/Linux/FreeBSD use
  <b>control-T</b> (i.e. Top)</td></tr>


<tr><td valign=top><b><font color="#006699">control-End</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to the end of the file. This works with ex.exe only.
  On Windows/Linux/FreeBSD use <b>control-B</b>, 
  (i.e. Bottom)</td></tr>


<tr><td valign=top><b><font color="#006699">Page Up</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move up one screen. In a Linux/FreeBSD xterm use <b>control-U</b></td></tr>


<tr><td valign=top><b><font color="#006699">Page Down</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move down one screen. In a Linux/FreeBSD xterm use <b>control-P</b></td></tr>


<tr><td valign=top><b><font color="#006699">F1 ... F10</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Select a new current window. The windows are numbered from top
   to bottom, with the top window on the screen being <b>F1</b>.</td></tr>


<tr><td valign=top><b><font color="#006699">F12</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>This is a special
   <font color="#CC0099"><b>customizable command</b></font>. It is set up
   to insert a Euphoria comment mark "--" at the start of the current line.
   You can easily <font color="#006633"><b>change it to perform any series
   of key strokes that you like</b></font>, simply by redefining
   constant CUSTOM_KEYSTROKES near the top of
   <font color="#5500FF"><b>ed.ex</b></font>.</td></tr>


</table>


<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Escape Commands

</font>
<p>
 Press and release the <font color="#006699"><b>Esc</b></font> key, then
 press one of the following keys:

<p>
<table border=0 cellspacing=2 cellpadding=2>

<tr><td valign=top><b><font color="#006699">h</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Get help text for the editor, or Euphoria. The screen is split
   so you can view your program and the help text at the same time.</td></tr>


<tr><td valign=top><b><font color="#006699">c</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>"Clone" the current window, i.e. make a new edit window that
   is initially viewing the same file at the same position as the current
   window. The sizes of all windows are adjusted to make room for the new
   window. You might want to use <b>Esc l</b> to get more lines on the screen.
   Each window that you create can be scrolled independently and each has its
   own menu bar. The changes that you make to a file will initially appear
   only in the current window. When you press an <b>F-key</b> to select a new
   window, any changes will appear there as well. You can use <b>Esc n</b> to
   read a new file into any window.</td></tr>


<tr><td valign=top><b><font color="#006699">q</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Quit (delete) the current window and leave the editor if there
   are no more windows. You'll be warned if this is the last window used for
   editing a modified file. Any remaining windows are given more space.</td></tr>


<tr><td valign=top><b><font color="#006699">s</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Save the file being edited in the current window, then quit the
   current window as <b>Esc q</b> above.</td></tr>


<tr><td valign=top><b><font color="#006699">w</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Save the file but do not quit the window.</td></tr>


<tr><td valign=top><b><font color="#006699">e</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Save the file, and then execute it with
   <font color="#993333"><b>ex</b></font>,
   <font color="#993333"><b>exw</b></font> or
   <font color="#993333"><b>exu</b></font>. When the program finishes
   execution you'll hear a beep. Hit <b>Enter</b> to return to the editor.
   This operation may not work if you are very low on extended memory. You
   can't supply any
   <font color="#993333"><b>command-line arguments</b></font> to the
   program.</td></tr>


<tr><td valign=top><b><font color="#006699">d</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Run an operating system command. After the beep, hit <b>Enter</b> to return
   to the editor. You could also use this command to edit another file and
   then return, but <b>Esc c</b> is probably more convenient.</td></tr>


<tr><td valign=top><b><font color="#006699">n</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Start editing a new file in the current window. Deleted
   lines/chars and search strings are available for use in the new file.
   You must type in the path to the new file. Alternatively, you can drag a
   file name from a Windows file manager window into the MS-DOS window for
   <font color="#993333"><b>ed</b></font>. This will type the full path for
   you.</td></tr>


<tr><td valign=top><b><font color="#006699">f</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Find the next occurrence of a string in the current window.
   When you type in a new string there is an option to "match case" or not.
   Press <b>y</b> if you require upper/lower case to match. Keep hitting
   <b>Enter</b> to find subsequent occurrences. Any other key stops the
   search. To search from the beginning, press <b>control-Home</b> before
   <b>Esc f</b>. The default string to search for, if you don't type anything,
   is shown in double quotes.</td></tr>


<tr><td valign=top><b><font color="#006699">r</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Globally replace one string by another. Operates like
  <b>Esc f</b> command. Keep hitting <b>Enter</b> to continue replacing.
  Be careful -- <i>there is no way to skip over a possible replacement.</i></td></tr>


<tr><td valign=top><b><font color="#006699">l</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Change the number of lines displayed on the screen. Only
   certain values are allowed, depending on your video card. Many cards will
   allow 25, 28, 43 and 50 lines. <p>In a Linux/FreeBSD text console 
   you're stuck 
   with the number of lines available (usually 25). In a Linux/FreeBSD xterm
   window, <b>ed</b> will use the number of lines initially available when
   ed is started up. Changing the size of the window will have no effect
   after ed is started.</td></tr>


<tr><td valign=top><b><font color="#006699">m</font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Show the modifications that you've made so far. The current
   edit buffer is saved as <font color="#993333"><b>editbuff.tmp</b></font>,
   and is compared with the file on disk using the DOS <b>fc</b> command,
   or the Linux/FreeBSD <b>diff</b> command.
   <b>Esc m</b> is very useful when you want to quit the editor, but you
   can't remember what changes you made, or whether it's ok to save them.
   It's also useful when you make an editing mistake and you want to see what
   the original text looked like.</td></tr>


<tr><td valign=top><b><font color="#006699"><i>ddd</i></font></b></td>
<td width=10 align=center valign=top>-</td>
<td>Move to line number <i>ddd</i>. e.g. <b>Esc 1023 Enter</b>
   would move to line 1023 in the file.</td></tr>


<tr><td valign=top><b><font color="#006699">CR</font></b></td>
<td width=10 align=center valign=top>-</td>
<td><b>Esc Carriage-Return</b>, i.e. <b>Esc Enter</b>, will
   tell you the name of the current file, as well as the line and character
   position you are on, and whether the file has been modified since the last
   save. If you press <b>Esc</b> and then change your mind, it is harmless
   to just hit <b>Enter</b> so you can go back to editing.</td></tr>


</table>

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Recalling Previous Strings

</font>
<p>
The <b>Esc n</b>, <b>Esc d</b>, <b>Esc r</b> and <b>Esc f</b> commands
prompt you to enter a string. You can recall and edit these strings
just as you would at the DOS or Linux/FreeBSD command line. Type up-arrow or
down-arrow to cycle through strings that you previously entered for
a given command, then use left-arrow, right-arrow and the delete key to
edit the strings. Press Enter to submit the string.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Cutting and Pasting

</font>
<p>
 When you <font color="#006699"><b>control-Delete</b></font> 
 (or <font color="#006699"><b>control-D</b></font>)
 a series of
 consecutive lines, or <font color="#006699"><b>Delete</b></font> a series
 of consecutive characters, you create a "kill-buffer" containing what you
 just deleted. This kill-buffer can be re-inserted by moving the cursor and
 then pressing <font color="#006699"><b>Insert</b></font>.
<p>
 A new kill-buffer is started, and the old buffer is lost, each time you move
 away and start deleting somewhere else. For example, cut a series of
 <b><i>lines</i></b> with
 <font color="#006699"><b>control-Delete</b></font>. Then move the
 cursor to where you want to paste the lines and press
 <font color="#006699"><b>Insert</b></font>. If you want to copy the lines,
 without destroying the original text, first
 <font color="#006699"><b>control-Delete</b></font> them, then immediately
 press <font color="#006699"><b>Insert</b></font> to re-insert them. Then
 move somewhere else and press <font color="#006699"><b>Insert</b></font> to
 insert them again, as many times as you like. You can also
 <font color="#006699"><b>Delete</b></font> a series of individual
 <b><i>characters</i></b>, move the cursor, and then paste the deleted
 characters somewhere else. Immediately press
 <font color="#006699"><b>Insert</b></font> after deleting if you want to
 copy without removing the original characters.
<p>
 Once you have a kill-buffer, you can type
 <font color="#006699"><b>Esc n</b></font> to read in a new file, or you can
 press an <font color="#006699"><b>F-key</b></font> to select a new edit
 window. You can then insert your kill-buffer.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Use of Tabs

</font>
<p>
 The standard <i>tab</i> width is 8 spaces. The editor assumes
 tab=8 for most files. However, it is more convenient when editing a
 program for a tab to equal the amount of space that you like to indent.
 Therefore you will find that tabs are set to 4 when you edit Euphoria files
 (or .c, or .h or .bas files). The editor converts from tab=8 to tab=4 when
 reading your <i>program</i> file, and converts back to tab=8 when you save
 the file. Thus your file remains compatible with the tab=8 world, e.g.
 MS-DOS PRINT, EDIT, etc. <font color="#006633"><b>If you would like to
 choose a different number of spaces to indent</b></font>, change the line
 at the top of <font color="#5500FF"><b>ed.ex</b></font> that says "constant
 PROG_INDENT = 4".

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Long Lines

</font>
<p>
 Lines that extend beyond the right edge of the screen are marked with an 
 <i>inverse video</i> character in the 80th column. This warns you that
 there is more text "out there" that you can't see. You can move the cursor
 beyond the 80th column. The screen will scroll left or right so the cursor
 position is always visible.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Maximum File Size

</font>
<p>
 Like any Euphoria program, <font color="#993333"><b>ed</b></font> can access
 all the memory on your machine. It can edit huge files, and unless 
 disk swapping occurs, most operations will be very fast.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Non-text Files

</font>
<p>
 <font color="#993333"><b>ed</b></font> is designed for editing pure text
 files, although you can use it to view other files. As
 <font color="#993333"><b>ed</b></font> reads in a file, it replaces certain
 non-printable characters (less than ASCII 14) with ASCII 254 - small square.
 <i>If you try to save a non-text file you will be warned about this.</i>
 (MS-DOS Edit will quietly corrupt a non-text file - do not save!).
 Since <font color="#993333"><b>ed</b></font> opens all files as "text" files,
 a <b>control-z</b> character (26) embedded in a file will appear to ed to be 
 the <i>end of the file</i>.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Long Filenames

</font>
<p>
 Although <b>ed</b> is a DOS editor, you can edit 
 <i>existing</i> files that have pathnames with long names in
 them, and the full file name will be preserved. However in this release
 <font color="#993333"><b>ed</b></font> will not create
 <b><i>new</i></b> files with long names. The name will be
 truncated to the standard DOS 8.3 length. (but see Platform below)

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>
Line Terminator

</font>
<p>
 The end-of-line terminator on Linux/FreeBSD is simply <b>\n</b>. On DOS
 and Windows, text files have lines ending with <b>\r\n</b>.
 If you copy a DOS or Windows file to Linux/FreeBSD and try to modify it,
 <b>ed</b> will give you a choice of either keeping the <b>\r\n</b> terminators,
 or saving the file with <b>\n</b> terminators.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Source Code

</font>
<p>
 The complete source code to this editor is in
 <font color="#5500FF"><b>bin\ed.ex</b></font> and
 <font color="#5500FF"><b>bin\syncolor.e</b></font>. 
 You are welcome to make improvements. There is a section at the top of
 <font color="#5500FF"><b>ed.ex</b></font> containing "user-modifiable"
 configuration parameters that you can adjust. The colors and the cursor
 size may need adjusting for some operating environments.

<p>

<font face="Arial, Helvetica" color="#FF0099" size=+1>
<br>

Platform

</font>
<p>
 <font color="#993333"><b>euphoria\bin\ed.bat</b></font> 
 can be set up to run ed.ex using
 <font color="#993333"><b>exwc.exe</b></font>
 or
 <font color="#993333"><b>ex.exe</b></font>.
 You are better off running ed
 with 
 <font color="#993333"><b>ex.exe</b></font> on Windows 95/98/ME.
 You'll get much quicker screen updates than with 
 <font color="#993333"><b>exwc.exe</b></font>.
 On Windows XP you'll be a bit better off using 
 <font color="#993333"><b>exwc.exe</b></font>.
 You'll get slightly quicker screen updates,
 and you'll be able to create files with long names, not just
 open existing ones. However some special keys won't work
 with <font color="#993333"><b>exwc.exe</b></font>, e.g.
 you'll have to use control-t and control-b instead of
 control-Home and control-End.
 On Linux and FreeBSD there are no problems with 
 long filenames, and the keyboard response is always fast.
 
<p>&nbsp;

</td></tr></table>

</body>
</html>

